//+------------------------------------------------------------------+
//|                                                    NoRepaint.mq4 |
//|                                                         Zen_Leow |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property indicator_chart_window
#property indicator_buffers 5

#property indicator_color1 DeepSkyBlue      
#property indicator_color2 DeepPink  
#property indicator_color3 DeepSkyBlue      
#property indicator_color4 DeepPink          


#property indicator_width1 1  
#property indicator_width2 1  
//+------------------------------------------------------------------+
extern ENUM_TIMEFRAMES    TimeFrame     = PERIOD_CURRENT;  // Time Frame
extern int                ArrowDistance = 3;               // Arrow Distance
//+------------------------------------------------------------------+
bool WaitForCandleClose = false;
bool ArrowOnTriggerBar = false;

double Up_Arrow_Buffer[];    
double Down_Arrow_Buffer[];  
double Right_Side_Buffer[];
int    RightSideCandleNum = 0;
int    SignalIndex = 0;
int    ArrowOffset = 0;

string IndFileName;
bool   returnBars;
double Trend[];
int init()
  {
    if (WaitForCandleClose)
     {
       SignalIndex = 1;
     }else{
       SignalIndex = 0;
     }
    IndicatorBuffers(4);
    
    SetIndexBuffer(0,Up_Arrow_Buffer);SetIndexStyle (0,DRAW_ARROW);SetIndexArrow (0,225);
    SetIndexBuffer(1,Down_Arrow_Buffer);SetIndexStyle (1,DRAW_ARROW);SetIndexArrow (1,226);   
    SetIndexBuffer(2,Right_Side_Buffer);SetIndexStyle (2,DRAW_NONE);
    SetIndexBuffer(3,Trend); SetIndexStyle (3,DRAW_NONE);
//---
    IndFileName = WindowExpertName();
    returnBars  = (TimeFrame==-99); 
    TimeFrame   = MathMax(TimeFrame,_Period);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int i,limit;                           
    int Counted_bars;                
  
    Counted_bars=IndicatorCounted();  
    
    i = Bars-Counted_bars; 
    if(Counted_bars==0) i=Bars-3;   
            
    if(i==0) i = 5;  
    
    limit = i;
    
    if(returnBars) {Up_Arrow_Buffer[0] = limit; return(0);}
//+------------------------------------------------------------------+
    if(TimeFrame!=_Period)
     {
       limit = (int)MathMax(limit,MathMin(Bars-3,iCustom(NULL,TimeFrame,IndFileName,-99,0,0)*TimeFrame/_Period));
       
       double SigUp;
       double SigDn;
       
       for(i=limit;i>=0; i--)
        {
          int y = iBarShift(NULL,TimeFrame,Time[i]);
  
          SigUp = iCustom(NULL,TimeFrame,IndFileName,PERIOD_CURRENT,0,y);
          SigDn = iCustom(NULL,TimeFrame,IndFileName,PERIOD_CURRENT,1,y);       
          
          Trend[i] = Trend[i+1];
          
          Up_Arrow_Buffer[i]   = EMPTY_VALUE;
          Down_Arrow_Buffer[i] = EMPTY_VALUE;
          
          if(SigUp==EMPTY_VALUE && SigDn==EMPTY_VALUE)
           Trend[i] = 0;
           
          if(SigUp!=EMPTY_VALUE && Trend[i]!=1)
           {
             Trend[i] = 1;
             Up_Arrow_Buffer[i] = SigUp;
           }else{
             if(SigDn!=EMPTY_VALUE && Trend[i]!=-1)
              {
                Trend[i] = -1;
                Down_Arrow_Buffer[i] = SigDn;
              }  
           }  
        }
      return(0);
     }  
//+------------------------------------------------------------------+
    while(i>SignalIndex)            
     {      
       if(isUpSwingBar(i))
        {
          if(ArrowOnTriggerBar)
           {
             ArrowOffset = RightSideCandleNum;
           }else{
             ArrowOffset = 0;
           }
          
          if(RightSideCandleNum == 1 || (RightSideCandleNum == 2 && i > SignalIndex+1))
           {
             Up_Arrow_Buffer[i-ArrowOffset]   = Low[i-ArrowOffset] - (ArrowDistance * Point);
             Down_Arrow_Buffer[i-ArrowOffset] = EMPTY_VALUE;
             Right_Side_Buffer[i] = RightSideCandleNum;
           }
        }else{
          if(isDownSwingBar(i))
           {
             if(ArrowOnTriggerBar)
              {
                ArrowOffset = RightSideCandleNum;
              }else{
                ArrowOffset = 0;
              }
            
             if(RightSideCandleNum == 1 || (RightSideCandleNum == 2 && i > SignalIndex+1))
              {
                Down_Arrow_Buffer[i-ArrowOffset] = High[i-ArrowOffset] + (ArrowDistance * Point);
                Up_Arrow_Buffer[i-ArrowOffset] = EMPTY_VALUE;
                Right_Side_Buffer[i] = RightSideCandleNum;
              }
           }else{
             if(ArrowOnTriggerBar)
              {
                ArrowOffset = Right_Side_Buffer[i];
              }else{
                ArrowOffset = 0;
              }
             
             Up_Arrow_Buffer[i-ArrowOffset] = EMPTY_VALUE;
             Down_Arrow_Buffer[i-ArrowOffset] = EMPTY_VALUE;
             Right_Side_Buffer[i] = EMPTY_VALUE;
           }
        }
       i--;
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool isUpSwingBar(int i)
  {
    if(UpSwingLeftOk(i) && UpSwingRightOk(i)) return (true);
    return (false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool UpSwingLeftOk(int i)
  {
    if(Low[i] < Low[i+1])
     {
        if(High[i] < High[i+1]) return(true);
         else
          if(Low[i] < Low[i+2] && High[i] < High[i+2]) return(true);
     }
    return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool UpSwingRightOk(int i)
  {
    if(Low[i] < Low[i-1])
     {
       if(High[i] < High[i-1])
        {
          RightSideCandleNum = 1;
          return (true);
        }else{
          if(Low[i] < Low[i-2] && High[i] < High[i-2])
           {
             RightSideCandleNum = 2;
             return (true);
           }
        }
     }
    return (false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool isDownSwingBar(int i)
  {
    if(DownSwingLeftOk(i) && DownSwingRightOk(i)) return (true);
    return (false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DownSwingLeftOk(int i)
  {
    if(High[i] > High[i+1])
     {
       if(Low[i] > Low[i+1])
         return (true);
        else
         if(Low[i] > Low[i+2] && High[i] > High[i+2]) return (true);
     }
    return (false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DownSwingRightOk(int i)
  {
    if(High[i] > High[i-1])
     {
       if(Low[i] > Low[i-1])
        {
          RightSideCandleNum = 1;
          return (true);
        }else{
          if(Low[i] > Low[i-2] && High[i] > High[i-2])
           {
             RightSideCandleNum = 2;
             return (true);
           }
        }
     }
    return (false);
  }
//+------------------------------------------------------------------+